import time 
from epics import caget,caput,PV

import iexcode.instruments.cfg as iex
from iexcode.instruments.AD_utilities import *

##############################################################################################################
##############################              Camera PV dictionary            ##############################
##############################################################################################################

def cam_pv_dictionary():
    """
    dictionary of pv names for the beamline cameras
    """
    d={
        1:"29id_ps1:",
        2:"29id_ps2:",
        3:"29id_ps3:",
        4:"29id_ps4:",
        5:"29idarv5:",
        6:"29id_ps6:",
        7:"29id_ps7:",
    }
    return d

##############################################################################################################
##############################             Endstation Cameras           ##############################
##############################################################################################################
   
def _enable_endstation_cameras(unused_off=True):
    """
    Turns on cameras related to a given endstation if they are connected
    unused_off=True turns off other cameras

    """
    endstation=iex.BL.endstation_name

    #For new endstation modify here:
    cam_dict={'ARPES':[0,1,2],
    'kappa':[3,4,6],
    'Octupole':[6]
    }  # index of cam_list 

    d=cam_pv_dictionary()
    for num in d.keys(): 
        pv=d[num]+"cam1:Acquire"   
        #camera in list
        if num in cam_dict[endstation]:
            #two connected to deal with network traffic
            PV(pv).connected
            time.sleep(0.1)
            if PV(pv).connected:  
                caput(pv,'Acquire')
            else:
                print(d[num]+" ioc in not running")
        #camera not in list
        else:
            if unused_off:
                if PV(pv).connected:  
                    caput(pv,'Done')

